/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * UserRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class UserRequest {
  @SerializedName("invitation_code")
  private String invitationCode = null;

  @SerializedName("username")
  private String username = null;

  @SerializedName("first_name")
  private String firstName = null;

  @SerializedName("last_name")
  private String lastName = null;

  @SerializedName("password")
  private String password = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("confirmation_language")
  private String confirmationLanguage = null;

  @SerializedName("confirmation_template")
  private String confirmationTemplate = null;

  public UserRequest invitationCode(String invitationCode) {
    this.invitationCode = invitationCode;
    return this;
  }

   /**
   * Invitation code sent to the users that enables them to register
   * @return invitationCode
  **/
  @ApiModelProperty(example = "ABCDEFGHIJKLMNOPQRSTUVWXYZ", required = true, value = "Invitation code sent to the users that enables them to register")
  public String getInvitationCode() {
    return invitationCode;
  }

  public void setInvitationCode(String invitationCode) {
    this.invitationCode = invitationCode;
  }

  public UserRequest username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Arbitrary name defined by the user or the client application. Ex: JohnDoe, JDoe, etc.
   * @return username
  **/
  @ApiModelProperty(example = "johndoe", value = "Arbitrary name defined by the user or the client application. Ex: JohnDoe, JDoe, etc.")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public UserRequest firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

   /**
   * First name
   * @return firstName
  **/
  @ApiModelProperty(example = "john", value = "First name")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public UserRequest lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

   /**
   * Last name
   * @return lastName
  **/
  @ApiModelProperty(example = "doe", value = "Last name")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public UserRequest password(String password) {
    this.password = password;
    return this;
  }

   /**
   * Password. Should respect psw policy
   * @return password
  **/
  @ApiModelProperty(example = "complexEnough!1", required = true, value = "Password. Should respect psw policy")
  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public UserRequest email(String email) {
    this.email = email;
    return this;
  }

   /**
   * Optional contact email
   * @return email
  **/
  @ApiModelProperty(example = "john@doe.com", value = "Optional contact email")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public UserRequest confirmationLanguage(String confirmationLanguage) {
    this.confirmationLanguage = confirmationLanguage;
    return this;
  }

   /**
   * Language in which the confirmation email will be sent. (ISO 639-1 two letters code)
   * @return confirmationLanguage
  **/
  @ApiModelProperty(example = "en", value = "Language in which the confirmation email will be sent. (ISO 639-1 two letters code)")
  public String getConfirmationLanguage() {
    return confirmationLanguage;
  }

  public void setConfirmationLanguage(String confirmationLanguage) {
    this.confirmationLanguage = confirmationLanguage;
  }

  public UserRequest confirmationTemplate(String confirmationTemplate) {
    this.confirmationTemplate = confirmationTemplate;
    return this;
  }

   /**
   * Preconfigured email template
   * @return confirmationTemplate
  **/
  @ApiModelProperty(example = "greatPartner_registrationTemplate", value = "Preconfigured email template")
  public String getConfirmationTemplate() {
    return confirmationTemplate;
  }

  public void setConfirmationTemplate(String confirmationTemplate) {
    this.confirmationTemplate = confirmationTemplate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserRequest userRequest = (UserRequest) o;
    return Objects.equals(this.invitationCode, userRequest.invitationCode) &&
        Objects.equals(this.username, userRequest.username) &&
        Objects.equals(this.firstName, userRequest.firstName) &&
        Objects.equals(this.lastName, userRequest.lastName) &&
        Objects.equals(this.password, userRequest.password) &&
        Objects.equals(this.email, userRequest.email) &&
        Objects.equals(this.confirmationLanguage, userRequest.confirmationLanguage) &&
        Objects.equals(this.confirmationTemplate, userRequest.confirmationTemplate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(invitationCode, username, firstName, lastName, password, email, confirmationLanguage, confirmationTemplate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserRequest {\n");
    
    sb.append("    invitationCode: ").append(toIndentedString(invitationCode)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    confirmationLanguage: ").append(toIndentedString(confirmationLanguage)).append("\n");
    sb.append("    confirmationTemplate: ").append(toIndentedString(confirmationTemplate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

